HDU-3189-Just Do It【分解质因数】


3189-Just Do It



Problem Description

Now we define a function F(x), which means the factors of x. In particular, F(1) = 1,since 1 only has 1 factor 1, F(9) = 3, since 9 has 3 factors 1, 3, 9. Now give you an integer k, please find out the minimum number x that makes F(x) = k.

Input

The first line contains an integer t means the number of test cases.

The follows t lines, each line contains an integer k. (0 < k <= 100).

Output

For each case, output the minimum number x in one line. If x is larger than 1000, just output -1.

Sample Input

4

4

2

5

92

Sample Output

6

2

16

-1

题目连接:HDU-3189

题目大意:求约数个数为k的最小数。

题目思路:先求出每个数字的质因数,然后dfs求出所有的约数。

以下是代码:

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <cstring>
#include <algorithm>
#include <string>
#include <set>
#include <functional>
#include <numeric>
#include <sstream>
#include <stack>
#include <map>
#include <queue>
#include<iomanip>
//#include<bits\stdc++.h>
#define ll unsigned long long
using namespace std;
#define MAXN 1010
#define ANS_SIZE 505
ll f[ANS_SIZE],nf[ANS_SIZE];  //f存放质因数,nf存放对应质因数的个数
ll plist[MAXN], pcount=0;
bool isPrime[MAXN+1];
void initprime()//素数且不说,所有合数都能分解成任意素数之积
{
    int i,j;
    pcount = 0;
    for(i = 2; i<MAXN; i++)
    {
        if(!isPrime[i]) plist[pcount++] = i;//打下素数表
        for(int j = 0; j<pcount && i*plist[j]<MAXN; j++)
        {
            isPrime[i*plist[j]] = true;//所有非素数排除
            if(i%plist[j]==0) break;
        }
    }
}

int prime_factor(ll n) {
    int cnt = 0;
    int n2 = (int)sqrt((double)n);
    for(int i = 0; n > 1 && plist[i] <= n2 && i < pcount; ++i)
    {
        if (n % plist[i] == 0) {
            for (nf[cnt] = 0; n % plist[i] == 0; ++nf[cnt], n /= plist[i]);
            f[cnt++] = plist[i];
        }
    }
    if (n > 1) nf[cnt] = 1, f[cnt++] = n;
    return cnt;   //返回不同质因数的个数
}

vector<ll> yue[1005];
void dfs( int x, int t, ll ss ,int numpos){
    if( x==t ) return;
    dfs( x+1, t, ss,numpos);
    for( int i=0 ; i<nf[x] ; i++ ){
        ss *= f[x];
        yue[numpos].push_back(ss);
        dfs( x+1, t, ss,numpos);
    }
}
int ans[1005];
int main(){
    ll m;
    initprime();
    for (int i = 1; i < 1005; i++)
    {
        memset(f,0,sizeof(f));
        memset(nf,0,sizeof(nf));
        int ret = prime_factor(i);
        yue[i].push_back (1);
        dfs(0,ret,1,i);
        ans[i] = yue[i].size();
    }
    cin >> m;
    while(m--)
    {
        int k;
        cin >> k;
        int flag = 0;
        for (int i = 1; i < 1005; i++)
        {
            if (ans[i] == k)
            {
                flag = 1;
                cout << i << endl;
                break;
            }
        }
        if (!flag) cout << -1 << endl;
    }
    return 0;
}
时间: 2024-10-11 22:59:26

HDU-3189-Just Do It【分解质因数】的相关文章

HDU 5428 [The Factor] 分解质因数

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5428 题目大意:给你若干个整数,让你输出这些数乘积的一个最小因子,并且这个因子至少有3个因子. 关键思想:分解质因数,我们要找的其实就是两个最小质因数的乘积.我的算法关键就是维护最小的两个质因数. 代码如下: #include <iostream> #include <cmath> #include <cstdio> #include <algorithm> u

大素数测试和分解质因数

Prime Test http://poj.org/problem?id=1811 1 #include<cstdio> 2 #include<algorithm> 3 using namespace std; 4 typedef __int64 LL; 5 LL mulmod(LL a,LL b,LL c) { //ret=(a*b)%c 6 LL ret=0; 7 for(; b; a=(a<<1)%c,b>>=1) { 8 if(b&1) {

HDU 3641 Treasure Hunting (二分+分解质因子)

题目链接:HDU 3641 Treasure Hunting 题意:求X!%M==0中最小的的X.其中M=a1^b1*a2^b2*a3^b3.... 思路:求余为0想到整除,即分母的因子构成的集合是分子的因子构成的集合的子集.因子又想到,任何一个整数都可以分解成若干个素数相乘. 注意:题目数据很大,查到答案时二分. AC代码: #include<stdio.h> #include<string.h> #define ll __int64 bool Prime[210]; ll nu

分解质因数模板

/*==================================================*| 分解质因数,可能有些地方需要改为long long \*==================================================*/ const int MAXN=100010; int prm[MAXN+1]; bool is[MAXN+1]; int getprm(int n){ int i, j, k = 0; int s, e = (int)(sqrt

java编程题 --分解质因数

package Solve; import java.util.Scanner; public class Solve { static Scanner scan = new Scanner(System.in); public static void main(String[] args) { System.out.println("请输入一个正整数:"); int num = scan.nextInt(); System.out.print(num + " = "

POJ 2773 Happy 2006 (分解质因数+容斥+二分 或 欧几里德算法应用)

Happy 2006 Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 10309   Accepted: 3566 Description Two positive integers are said to be relatively prime to each other if the Great Common Divisor (GCD) is 1. For instance, 1, 3, 5, 7, 9...are a

codevs 1792 分解质因数

1792 分解质因数 题目描述 Description 编写一个把整数N分解为质因数乘积的程序. 输入描述 Input Description 输入一个整数 N 输出描述 Output Description 输出 分解质因数 .拆成几个质数相乘的形式,质数必须从小到大相乘 样例输入 Sample Input 756 样例输出 Sample Output 756=2*2*3*3*3*7 #include<cstdio> #include<cmath> #include<str

代码实现:将一个正整数分解质因数。例如:输入90,打印出90=2*3*3*5

import java.util.Scanner; /*题目:将一个正整数分解质因数.例如:输入90,打印出90=2*3*3*5. 程序分析:对n进行分解质因数,应先找到一个最小的质数k,然后按下述步骤完成: (1)如果这个质数恰等于n,则说明分解质因数的过程已经结束,打印出即可. (2)如果n<>k,但n能被k整除,则应打印出k的值,并用n除以k的商,作为新的正整数n,重复执行第一步. (3)如果n不能被k整除,则用k+1作为k的值,重复执行第一步.*/ public class Test

分解质因数

package java算法; /** * 任意整数分解 题目:将一个正整数分解质因数.例如:输入90,打印出90=2*3*3*5. * 程序分析:对n进行分解质因数,应先找到一个最小的质数k,然后按下述步骤完成: (1)如果这个质数恰等于n,则说明分解质因数的过程已经结束,打印出即可. * (2)如果n>k,但n能被k整除,则应打印出k的值,并用n除以k的商,作为新的正整数你n,重复执行第一步. * (3)如果n不能被k整除,则用k+1作为k的值,重复执行第一步. * * @author to

uva10780(分解质因数)

可以直接用高精度来暴力求. 也可以不用高精度: 把m分解质因数,记录每个因数和它的次数.然后计算每个因数在n的阶乘里出现了多少次,再把这个次数除以它在m中的次数,就是可能的k值.取最小的k. #include<iostream> #include<cstdio> #include<cstdlib> #include<cstring> #include<cmath> #include<map> #include<set> #